// -*- c++ -*-
/* This is a generated file, do not edit.  Generated from ../../sigcx/sigc++/macros/corba_convert.h.m4 */

#ifndef SIGCXX_CORBA_CONVERT_H
#define SIGCXX_CORBA_CONVERT_H

/*
  corbaSigC::convert
  -------------
  convert() alters a Slot by assigning a conversion function 
  which can completely alter the parameter types of a slot. 

*/
#include <sigc++/adaptor.h>
#include <sigc++/convert.h>

#include <sigc++/corba_base.h>

#ifdef SIGC_CXX_NAMESPACES
namespace SigC
{
#endif

using namespace corbaSigC;

template <typename T>
struct CORBATraits
{
  typedef T in_type;
  typedef T& out_type;
}; 

#ifdef SIGC_CXX_PARTIAL_SPEC
template <>
struct CORBATraits<int>
{
  typedef CORBA::Long in_type;
  typedef CORBA::Long out_type;
};

template <>
struct CORBATraits<const char *>
{
  typedef const char *in_type;
};

#endif









/****************************************************************
***** Adaptor Convert Slot 1
****************************************************************/
template <class R, class P1>
CORBA::Any *_corba_unmarshal_convert_1(Callback1<R,P1>* d, const ParamList& params)
  {
    P1 p1_;

    if (params.length() < 1)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_;
    R retval = d->call(p1_);
    CORBA::Any *any_retval = new CORBA::Any();
    *any_retval <<= CORBATraits<R>::in_type(retval);
    return(any_retval);
  }


template <class R,class P1>
R _corba_marshal_convert_1(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1)

  {
    ParamList params;
    params.length(1);
    params[0] <<= CORBATraits<P1>::in_type(p1);
    CORBA::Any *any_retval = d->call(params);
    R retval;
    if (any_retval)
    {
      *any_retval >>= CORBATraits<R>::out_type(retval);
      delete any_retval;
    }
    return(retval);
  }


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1>
CORBA::Any *_corba_unmarshal_convert_1(Callback1<void,P1>* d, const ParamList& params)
  {
    P1 p1_;

    if (params.length() < 1)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_;
    d->call(p1_);
    return(new CORBA::Any());
  }


template <class P1>
void _corba_marshal_convert_1(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1)

  {
    ParamList params;
    params.length(1);
    params[0] <<= CORBATraits<P1>::in_type(p1);
    CORBA::Any *any_retval = d->call(params);
    if (any_retval)
      delete any_retval;
  }

#endif
#endif

template <class R,class P1>
Slot1<R,P1>
  convert(const Slot1<CORBA::Any*,const ParamList&> &s)
  {return convert(s, &_corba_marshal_convert_1<R, P1>);
  }

template <class R1,class P1>
Slot1<CORBA::Any*,const ParamList&>
  convert(const Slot1<R1,P1> &s)
  {return convert(s, &_corba_unmarshal_convert_1<R1, P1>);
  }

/****************************************************************
***** Adaptor Convert Slot 2
****************************************************************/
template <class R, class P1,class P2>
CORBA::Any *_corba_unmarshal_convert_2(Callback2<R,P1,P2>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_;

    if (params.length() < 2)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_;
    R retval = d->call(p1_,p2_);
    CORBA::Any *any_retval = new CORBA::Any();
    *any_retval <<= CORBATraits<R>::in_type(retval);
    return(any_retval);
  }


template <class R,class P1,class P2>
R _corba_marshal_convert_2(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2)

  {
    ParamList params;
    params.length(2);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2);
    CORBA::Any *any_retval = d->call(params);
    R retval;
    if (any_retval)
    {
      *any_retval >>= CORBATraits<R>::out_type(retval);
      delete any_retval;
    }
    return(retval);
  }


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2>
CORBA::Any *_corba_unmarshal_convert_2(Callback2<void,P1,P2>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_;

    if (params.length() < 2)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_;
    d->call(p1_,p2_);
    return(new CORBA::Any());
  }


template <class P1,class P2>
void _corba_marshal_convert_2(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2)

  {
    ParamList params;
    params.length(2);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2);
    CORBA::Any *any_retval = d->call(params);
    if (any_retval)
      delete any_retval;
  }

#endif
#endif

template <class R,class P1,class P2>
Slot2<R,P1,P2>
  convert(const Slot1<CORBA::Any*,const ParamList&> &s)
  {return convert(s, &_corba_marshal_convert_2<R, P1,P2>);
  }

template <class R1,class P1,class P2>
Slot1<CORBA::Any*,const ParamList&>
  convert(const Slot2<R1,P1,P2> &s)
  {return convert(s, &_corba_unmarshal_convert_2<R1, P1,P2>);
  }

/****************************************************************
***** Adaptor Convert Slot 3
****************************************************************/
template <class R, class P1,class P2,class P3>
CORBA::Any *_corba_unmarshal_convert_3(Callback3<R,P1,P2,P3>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_; P3 p3_;

    if (params.length() < 3)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_; params[2] >>= p3_;
    R retval = d->call(p1_,p2_,p3_);
    CORBA::Any *any_retval = new CORBA::Any();
    *any_retval <<= CORBATraits<R>::in_type(retval);
    return(any_retval);
  }


template <class R,class P1,class P2,class P3>
R _corba_marshal_convert_3(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2,P3 p3)

  {
    ParamList params;
    params.length(3);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2); params[2] <<= CORBATraits<P3>::in_type(p3);
    CORBA::Any *any_retval = d->call(params);
    R retval;
    if (any_retval)
    {
      *any_retval >>= CORBATraits<R>::out_type(retval);
      delete any_retval;
    }
    return(retval);
  }


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3>
CORBA::Any *_corba_unmarshal_convert_3(Callback3<void,P1,P2,P3>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_; P3 p3_;

    if (params.length() < 3)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_; params[2] >>= p3_;
    d->call(p1_,p2_,p3_);
    return(new CORBA::Any());
  }


template <class P1,class P2,class P3>
void _corba_marshal_convert_3(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2,P3 p3)

  {
    ParamList params;
    params.length(3);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2); params[2] <<= CORBATraits<P3>::in_type(p3);
    CORBA::Any *any_retval = d->call(params);
    if (any_retval)
      delete any_retval;
  }

#endif
#endif

template <class R,class P1,class P2,class P3>
Slot3<R,P1,P2,P3>
  convert(const Slot1<CORBA::Any*,const ParamList&> &s)
  {return convert(s, &_corba_marshal_convert_3<R, P1,P2,P3>);
  }

template <class R1,class P1,class P2,class P3>
Slot1<CORBA::Any*,const ParamList&>
  convert(const Slot3<R1,P1,P2,P3> &s)
  {return convert(s, &_corba_unmarshal_convert_3<R1, P1,P2,P3>);
  }

/****************************************************************
***** Adaptor Convert Slot 4
****************************************************************/
template <class R, class P1,class P2,class P3,class P4>
CORBA::Any *_corba_unmarshal_convert_4(Callback4<R,P1,P2,P3,P4>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_; P3 p3_; P4 p4_;

    if (params.length() < 4)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_; params[2] >>= p3_; params[3] >>= p4_;
    R retval = d->call(p1_,p2_,p3_,p4_);
    CORBA::Any *any_retval = new CORBA::Any();
    *any_retval <<= CORBATraits<R>::in_type(retval);
    return(any_retval);
  }


template <class R,class P1,class P2,class P3,class P4>
R _corba_marshal_convert_4(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2,P3 p3,P4 p4)

  {
    ParamList params;
    params.length(4);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2); params[2] <<= CORBATraits<P3>::in_type(p3); params[3] <<= CORBATraits<P4>::in_type(p4);
    CORBA::Any *any_retval = d->call(params);
    R retval;
    if (any_retval)
    {
      *any_retval >>= CORBATraits<R>::out_type(retval);
      delete any_retval;
    }
    return(retval);
  }


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4>
CORBA::Any *_corba_unmarshal_convert_4(Callback4<void,P1,P2,P3,P4>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_; P3 p3_; P4 p4_;

    if (params.length() < 4)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_; params[2] >>= p3_; params[3] >>= p4_;
    d->call(p1_,p2_,p3_,p4_);
    return(new CORBA::Any());
  }


template <class P1,class P2,class P3,class P4>
void _corba_marshal_convert_4(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2,P3 p3,P4 p4)

  {
    ParamList params;
    params.length(4);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2); params[2] <<= CORBATraits<P3>::in_type(p3); params[3] <<= CORBATraits<P4>::in_type(p4);
    CORBA::Any *any_retval = d->call(params);
    if (any_retval)
      delete any_retval;
  }

#endif
#endif

template <class R,class P1,class P2,class P3,class P4>
Slot4<R,P1,P2,P3,P4>
  convert(const Slot1<CORBA::Any*,const ParamList&> &s)
  {return convert(s, &_corba_marshal_convert_4<R, P1,P2,P3,P4>);
  }

template <class R1,class P1,class P2,class P3,class P4>
Slot1<CORBA::Any*,const ParamList&>
  convert(const Slot4<R1,P1,P2,P3,P4> &s)
  {return convert(s, &_corba_unmarshal_convert_4<R1, P1,P2,P3,P4>);
  }

/****************************************************************
***** Adaptor Convert Slot 5
****************************************************************/
template <class R, class P1,class P2,class P3,class P4,class P5>
CORBA::Any *_corba_unmarshal_convert_5(Callback5<R,P1,P2,P3,P4,P5>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_;

    if (params.length() < 5)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_; params[2] >>= p3_; params[3] >>= p4_; params[4] >>= p5_;
    R retval = d->call(p1_,p2_,p3_,p4_,p5_);
    CORBA::Any *any_retval = new CORBA::Any();
    *any_retval <<= CORBATraits<R>::in_type(retval);
    return(any_retval);
  }


template <class R,class P1,class P2,class P3,class P4,class P5>
R _corba_marshal_convert_5(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2,P3 p3,P4 p4,P5 p5)

  {
    ParamList params;
    params.length(5);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2); params[2] <<= CORBATraits<P3>::in_type(p3); params[3] <<= CORBATraits<P4>::in_type(p4); params[4] <<= CORBATraits<P5>::in_type(p5);
    CORBA::Any *any_retval = d->call(params);
    R retval;
    if (any_retval)
    {
      *any_retval >>= CORBATraits<R>::out_type(retval);
      delete any_retval;
    }
    return(retval);
  }


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4,class P5>
CORBA::Any *_corba_unmarshal_convert_5(Callback5<void,P1,P2,P3,P4,P5>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_;

    if (params.length() < 5)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_; params[2] >>= p3_; params[3] >>= p4_; params[4] >>= p5_;
    d->call(p1_,p2_,p3_,p4_,p5_);
    return(new CORBA::Any());
  }


template <class P1,class P2,class P3,class P4,class P5>
void _corba_marshal_convert_5(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2,P3 p3,P4 p4,P5 p5)

  {
    ParamList params;
    params.length(5);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2); params[2] <<= CORBATraits<P3>::in_type(p3); params[3] <<= CORBATraits<P4>::in_type(p4); params[4] <<= CORBATraits<P5>::in_type(p5);
    CORBA::Any *any_retval = d->call(params);
    if (any_retval)
      delete any_retval;
  }

#endif
#endif

template <class R,class P1,class P2,class P3,class P4,class P5>
Slot5<R,P1,P2,P3,P4,P5>
  convert(const Slot1<CORBA::Any*,const ParamList&> &s)
  {return convert(s, &_corba_marshal_convert_5<R, P1,P2,P3,P4,P5>);
  }

template <class R1,class P1,class P2,class P3,class P4,class P5>
Slot1<CORBA::Any*,const ParamList&>
  convert(const Slot5<R1,P1,P2,P3,P4,P5> &s)
  {return convert(s, &_corba_unmarshal_convert_5<R1, P1,P2,P3,P4,P5>);
  }

/****************************************************************
***** Adaptor Convert Slot 6
****************************************************************/
template <class R, class P1,class P2,class P3,class P4,class P5,class P6>
CORBA::Any *_corba_unmarshal_convert_6(Callback6<R,P1,P2,P3,P4,P5,P6>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_; P6 p6_;

    if (params.length() < 6)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_; params[2] >>= p3_; params[3] >>= p4_; params[4] >>= p5_; params[5] >>= p6_;
    R retval = d->call(p1_,p2_,p3_,p4_,p5_,p6_);
    CORBA::Any *any_retval = new CORBA::Any();
    *any_retval <<= CORBATraits<R>::in_type(retval);
    return(any_retval);
  }


template <class R,class P1,class P2,class P3,class P4,class P5,class P6>
R _corba_marshal_convert_6(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6)

  {
    ParamList params;
    params.length(6);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2); params[2] <<= CORBATraits<P3>::in_type(p3); params[3] <<= CORBATraits<P4>::in_type(p4); params[4] <<= CORBATraits<P5>::in_type(p5); params[5] <<= CORBATraits<P6>::in_type(p6);
    CORBA::Any *any_retval = d->call(params);
    R retval;
    if (any_retval)
    {
      *any_retval >>= CORBATraits<R>::out_type(retval);
      delete any_retval;
    }
    return(retval);
  }


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4,class P5,class P6>
CORBA::Any *_corba_unmarshal_convert_6(Callback6<void,P1,P2,P3,P4,P5,P6>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_; P6 p6_;

    if (params.length() < 6)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_; params[2] >>= p3_; params[3] >>= p4_; params[4] >>= p5_; params[5] >>= p6_;
    d->call(p1_,p2_,p3_,p4_,p5_,p6_);
    return(new CORBA::Any());
  }


template <class P1,class P2,class P3,class P4,class P5,class P6>
void _corba_marshal_convert_6(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6)

  {
    ParamList params;
    params.length(6);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2); params[2] <<= CORBATraits<P3>::in_type(p3); params[3] <<= CORBATraits<P4>::in_type(p4); params[4] <<= CORBATraits<P5>::in_type(p5); params[5] <<= CORBATraits<P6>::in_type(p6);
    CORBA::Any *any_retval = d->call(params);
    if (any_retval)
      delete any_retval;
  }

#endif
#endif

template <class R,class P1,class P2,class P3,class P4,class P5,class P6>
Slot6<R,P1,P2,P3,P4,P5,P6>
  convert(const Slot1<CORBA::Any*,const ParamList&> &s)
  {return convert(s, &_corba_marshal_convert_6<R, P1,P2,P3,P4,P5,P6>);
  }

template <class R1,class P1,class P2,class P3,class P4,class P5,class P6>
Slot1<CORBA::Any*,const ParamList&>
  convert(const Slot6<R1,P1,P2,P3,P4,P5,P6> &s)
  {return convert(s, &_corba_unmarshal_convert_6<R1, P1,P2,P3,P4,P5,P6>);
  }

/****************************************************************
***** Adaptor Convert Slot 7
****************************************************************/
template <class R, class P1,class P2,class P3,class P4,class P5,class P6,class P7>
CORBA::Any *_corba_unmarshal_convert_7(Callback7<R,P1,P2,P3,P4,P5,P6,P7>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_; P6 p6_; P7 p7_;

    if (params.length() < 7)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_; params[2] >>= p3_; params[3] >>= p4_; params[4] >>= p5_; params[5] >>= p6_; params[6] >>= p7_;
    R retval = d->call(p1_,p2_,p3_,p4_,p5_,p6_,p7_);
    CORBA::Any *any_retval = new CORBA::Any();
    *any_retval <<= CORBATraits<R>::in_type(retval);
    return(any_retval);
  }


template <class R,class P1,class P2,class P3,class P4,class P5,class P6,class P7>
R _corba_marshal_convert_7(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6,P7 p7)

  {
    ParamList params;
    params.length(7);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2); params[2] <<= CORBATraits<P3>::in_type(p3); params[3] <<= CORBATraits<P4>::in_type(p4); params[4] <<= CORBATraits<P5>::in_type(p5); params[5] <<= CORBATraits<P6>::in_type(p6); params[6] <<= CORBATraits<P7>::in_type(p7);
    CORBA::Any *any_retval = d->call(params);
    R retval;
    if (any_retval)
    {
      *any_retval >>= CORBATraits<R>::out_type(retval);
      delete any_retval;
    }
    return(retval);
  }


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4,class P5,class P6,class P7>
CORBA::Any *_corba_unmarshal_convert_7(Callback7<void,P1,P2,P3,P4,P5,P6,P7>* d, const ParamList& params)
  {
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_; P6 p6_; P7 p7_;

    if (params.length() < 7)
      throw CORBA::BAD_PARAM();
    params[0] >>= p1_; params[1] >>= p2_; params[2] >>= p3_; params[3] >>= p4_; params[4] >>= p5_; params[5] >>= p6_; params[6] >>= p7_;
    d->call(p1_,p2_,p3_,p4_,p5_,p6_,p7_);
    return(new CORBA::Any());
  }


template <class P1,class P2,class P3,class P4,class P5,class P6,class P7>
void _corba_marshal_convert_7(Callback1<CORBA::Any*,const ParamList&>* d, P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6,P7 p7)

  {
    ParamList params;
    params.length(7);
    params[0] <<= CORBATraits<P1>::in_type(p1); params[1] <<= CORBATraits<P2>::in_type(p2); params[2] <<= CORBATraits<P3>::in_type(p3); params[3] <<= CORBATraits<P4>::in_type(p4); params[4] <<= CORBATraits<P5>::in_type(p5); params[5] <<= CORBATraits<P6>::in_type(p6); params[6] <<= CORBATraits<P7>::in_type(p7);
    CORBA::Any *any_retval = d->call(params);
    if (any_retval)
      delete any_retval;
  }

#endif
#endif

template <class R,class P1,class P2,class P3,class P4,class P5,class P6,class P7>
Slot7<R,P1,P2,P3,P4,P5,P6,P7>
  convert(const Slot1<CORBA::Any*,const ParamList&> &s)
  {return convert(s, &_corba_marshal_convert_7<R, P1,P2,P3,P4,P5,P6,P7>);
  }

template <class R1,class P1,class P2,class P3,class P4,class P5,class P6,class P7>
Slot1<CORBA::Any*,const ParamList&>
  convert(const Slot7<R1,P1,P2,P3,P4,P5,P6,P7> &s)
  {return convert(s, &_corba_unmarshal_convert_7<R1, P1,P2,P3,P4,P5,P6,P7>);
  }


#ifdef SIGC_CXX_NAMESPACES
} // namespace
#endif

#endif
