// -*- c++ -*-
/* This is a generated file, do not edit.  Generated from ../../sigcx/sigc++/macros/tunnel.h.m4 */

#ifndef SIGCXX_TUNNEL_H
#define SIGCXX_TUNNEL_H

#include <sigc++/slot.h>
#include <sigc++/object_slot.h>
#include <sigc++/bind.h>

#ifdef SIGC_CXX_NAMESPACES
namespace SigC
{
#endif

class Tunnel
{
  public:
    class Callback
    {
      public:
        virtual ~Callback() { }
        virtual void invoke() = 0;
    };

    virtual ~Tunnel() { }
    
    virtual void send(Callback *cb, bool sync = false) = 0;
};



/****************************************************************
*****  Tunnel 0
****************************************************************/

template <class R>
class TunnelCallback0 : public Tunnel::Callback
{
  public:
    TunnelCallback0(Slot0<R> slot)
: slot_(slot) {}
    virtual void invoke() { rv_ = slot_.call(); }
    R tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        R tmp;
        if (sync) {
          tmp = rv_;
	  delete this;
        }
        return(tmp);
      }
      else
        return(slot_.call());
    }
    static R tunnel(Slot0<R> s,Tunnel *tunnel,bool sync) {
      TunnelCallback0<R> *cb = pack(s);
      return(cb->tunnel(tunnel, sync));
    }
  protected:
    Slot0<R> slot_;
    R rv_;
    
};

template <class R>
   TunnelCallback0<R> *pack(Slot0<R> s)
  {       return(new TunnelCallback0<R>(s));
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <>
class TunnelCallback0<void> : public Tunnel::Callback
{
  public:
    TunnelCallback0(Slot0<void> slot)
: slot_(slot) { }
    virtual void invoke() { slot_.call(); }
    void tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        if (sync)
          delete this;
      }
      else
        slot_.call();
    }
    static void tunnel(Slot0<void> s,Tunnel *tunnel,bool sync) {
      TunnelCallback0<void> *cb = pack(s);
      cb->tunnel(tunnel, sync);
   }
  protected:
    Slot0<void> slot_;
    
};
#endif

template <class R>
Slot0<R>
  open_tunnel(Tunnel *tunnel, Slot0<R> s, bool sync)
  { return(bind(slot(&TunnelCallback0<R>::tunnel), s, tunnel, sync));
  }



/****************************************************************
*****  Tunnel 1
****************************************************************/

template <class R,class P1>
class TunnelCallback1 : public Tunnel::Callback
{
  public:
    TunnelCallback1(Slot1<R,P1> slot,P1 p1)
: slot_(slot),p1_(p1) {}
    virtual void invoke() { rv_ = slot_.call(p1_); }
    R tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        R tmp;
        if (sync) {
          tmp = rv_;
	  delete this;
        }
        return(tmp);
      }
      else
        return(slot_.call(p1_));
    }
    static R tunnel(P1 p1,Slot1<R,P1> s,Tunnel *tunnel,bool sync) {
      TunnelCallback1<R,P1> *cb = pack(s,p1);
      return(cb->tunnel(tunnel, sync));
    }
  protected:
    Slot1<R,P1> slot_;
    R rv_;
    P1 p1_;
};

template <class R,class P1>
   TunnelCallback1<R,P1> *pack(Slot1<R,P1> s,P1 p1)
  {       return(new TunnelCallback1<R,P1>(s,p1));
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1>
class TunnelCallback1<void,P1> : public Tunnel::Callback
{
  public:
    TunnelCallback1(Slot1<void,P1> slot,P1 p1)
: slot_(slot),p1_(p1) { }
    virtual void invoke() { slot_.call(p1_); }
    void tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        if (sync)
          delete this;
      }
      else
        slot_.call(p1_);
    }
    static void tunnel(P1 p1,Slot1<void,P1> s,Tunnel *tunnel,bool sync) {
      TunnelCallback1<void,P1> *cb = pack(s,p1);
      cb->tunnel(tunnel, sync);
   }
  protected:
    Slot1<void,P1> slot_;
    P1 p1_;
};
#endif

template <class R,class P1>
Slot1<R,P1>
  open_tunnel(Tunnel *tunnel, Slot1<R,P1> s, bool sync)
  { return(bind(slot(&TunnelCallback1<R,P1>::tunnel), s, tunnel, sync));
  }



/****************************************************************
*****  Tunnel 2
****************************************************************/

template <class R,class P1,class P2>
class TunnelCallback2 : public Tunnel::Callback
{
  public:
    TunnelCallback2(Slot2<R,P1,P2> slot,P1 p1,P2 p2)
: slot_(slot),p1_(p1),p2_(p2) {}
    virtual void invoke() { rv_ = slot_.call(p1_,p2_); }
    R tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        R tmp;
        if (sync) {
          tmp = rv_;
	  delete this;
        }
        return(tmp);
      }
      else
        return(slot_.call(p1_,p2_));
    }
    static R tunnel(P1 p1,P2 p2,Slot2<R,P1,P2> s,Tunnel *tunnel,bool sync) {
      TunnelCallback2<R,P1,P2> *cb = pack(s,p1,p2);
      return(cb->tunnel(tunnel, sync));
    }
  protected:
    Slot2<R,P1,P2> slot_;
    R rv_;
    P1 p1_; P2 p2_;
};

template <class R,class P1,class P2>
   TunnelCallback2<R,P1,P2> *pack(Slot2<R,P1,P2> s,P1 p1,P2 p2)
  {       return(new TunnelCallback2<R,P1,P2>(s,p1,p2));
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2>
class TunnelCallback2<void,P1,P2> : public Tunnel::Callback
{
  public:
    TunnelCallback2(Slot2<void,P1,P2> slot,P1 p1,P2 p2)
: slot_(slot),p1_(p1),p2_(p2) { }
    virtual void invoke() { slot_.call(p1_,p2_); }
    void tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        if (sync)
          delete this;
      }
      else
        slot_.call(p1_,p2_);
    }
    static void tunnel(P1 p1,P2 p2,Slot2<void,P1,P2> s,Tunnel *tunnel,bool sync) {
      TunnelCallback2<void,P1,P2> *cb = pack(s,p1,p2);
      cb->tunnel(tunnel, sync);
   }
  protected:
    Slot2<void,P1,P2> slot_;
    P1 p1_; P2 p2_;
};
#endif

template <class R,class P1,class P2>
Slot2<R,P1,P2>
  open_tunnel(Tunnel *tunnel, Slot2<R,P1,P2> s, bool sync)
  { return(bind(slot(&TunnelCallback2<R,P1,P2>::tunnel), s, tunnel, sync));
  }



/****************************************************************
*****  Tunnel 3
****************************************************************/

template <class R,class P1,class P2,class P3>
class TunnelCallback3 : public Tunnel::Callback
{
  public:
    TunnelCallback3(Slot3<R,P1,P2,P3> slot,P1 p1,P2 p2,P3 p3)
: slot_(slot),p1_(p1),p2_(p2),p3_(p3) {}
    virtual void invoke() { rv_ = slot_.call(p1_,p2_,p3_); }
    R tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        R tmp;
        if (sync) {
          tmp = rv_;
	  delete this;
        }
        return(tmp);
      }
      else
        return(slot_.call(p1_,p2_,p3_));
    }
    static R tunnel(P1 p1,P2 p2,P3 p3,Slot3<R,P1,P2,P3> s,Tunnel *tunnel,bool sync) {
      TunnelCallback3<R,P1,P2,P3> *cb = pack(s,p1,p2,p3);
      return(cb->tunnel(tunnel, sync));
    }
  protected:
    Slot3<R,P1,P2,P3> slot_;
    R rv_;
    P1 p1_; P2 p2_; P3 p3_;
};

template <class R,class P1,class P2,class P3>
   TunnelCallback3<R,P1,P2,P3> *pack(Slot3<R,P1,P2,P3> s,P1 p1,P2 p2,P3 p3)
  {       return(new TunnelCallback3<R,P1,P2,P3>(s,p1,p2,p3));
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3>
class TunnelCallback3<void,P1,P2,P3> : public Tunnel::Callback
{
  public:
    TunnelCallback3(Slot3<void,P1,P2,P3> slot,P1 p1,P2 p2,P3 p3)
: slot_(slot),p1_(p1),p2_(p2),p3_(p3) { }
    virtual void invoke() { slot_.call(p1_,p2_,p3_); }
    void tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        if (sync)
          delete this;
      }
      else
        slot_.call(p1_,p2_,p3_);
    }
    static void tunnel(P1 p1,P2 p2,P3 p3,Slot3<void,P1,P2,P3> s,Tunnel *tunnel,bool sync) {
      TunnelCallback3<void,P1,P2,P3> *cb = pack(s,p1,p2,p3);
      cb->tunnel(tunnel, sync);
   }
  protected:
    Slot3<void,P1,P2,P3> slot_;
    P1 p1_; P2 p2_; P3 p3_;
};
#endif

template <class R,class P1,class P2,class P3>
Slot3<R,P1,P2,P3>
  open_tunnel(Tunnel *tunnel, Slot3<R,P1,P2,P3> s, bool sync)
  { return(bind(slot(&TunnelCallback3<R,P1,P2,P3>::tunnel), s, tunnel, sync));
  }



/****************************************************************
*****  Tunnel 4
****************************************************************/

template <class R,class P1,class P2,class P3,class P4>
class TunnelCallback4 : public Tunnel::Callback
{
  public:
    TunnelCallback4(Slot4<R,P1,P2,P3,P4> slot,P1 p1,P2 p2,P3 p3,P4 p4)
: slot_(slot),p1_(p1),p2_(p2),p3_(p3),p4_(p4) {}
    virtual void invoke() { rv_ = slot_.call(p1_,p2_,p3_,p4_); }
    R tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        R tmp;
        if (sync) {
          tmp = rv_;
	  delete this;
        }
        return(tmp);
      }
      else
        return(slot_.call(p1_,p2_,p3_,p4_));
    }
    static R tunnel(P1 p1,P2 p2,P3 p3,P4 p4,Slot4<R,P1,P2,P3,P4> s,Tunnel *tunnel,bool sync) {
      TunnelCallback4<R,P1,P2,P3,P4> *cb = pack(s,p1,p2,p3,p4);
      return(cb->tunnel(tunnel, sync));
    }
  protected:
    Slot4<R,P1,P2,P3,P4> slot_;
    R rv_;
    P1 p1_; P2 p2_; P3 p3_; P4 p4_;
};

template <class R,class P1,class P2,class P3,class P4>
   TunnelCallback4<R,P1,P2,P3,P4> *pack(Slot4<R,P1,P2,P3,P4> s,P1 p1,P2 p2,P3 p3,P4 p4)
  {       return(new TunnelCallback4<R,P1,P2,P3,P4>(s,p1,p2,p3,p4));
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4>
class TunnelCallback4<void,P1,P2,P3,P4> : public Tunnel::Callback
{
  public:
    TunnelCallback4(Slot4<void,P1,P2,P3,P4> slot,P1 p1,P2 p2,P3 p3,P4 p4)
: slot_(slot),p1_(p1),p2_(p2),p3_(p3),p4_(p4) { }
    virtual void invoke() { slot_.call(p1_,p2_,p3_,p4_); }
    void tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        if (sync)
          delete this;
      }
      else
        slot_.call(p1_,p2_,p3_,p4_);
    }
    static void tunnel(P1 p1,P2 p2,P3 p3,P4 p4,Slot4<void,P1,P2,P3,P4> s,Tunnel *tunnel,bool sync) {
      TunnelCallback4<void,P1,P2,P3,P4> *cb = pack(s,p1,p2,p3,p4);
      cb->tunnel(tunnel, sync);
   }
  protected:
    Slot4<void,P1,P2,P3,P4> slot_;
    P1 p1_; P2 p2_; P3 p3_; P4 p4_;
};
#endif

template <class R,class P1,class P2,class P3,class P4>
Slot4<R,P1,P2,P3,P4>
  open_tunnel(Tunnel *tunnel, Slot4<R,P1,P2,P3,P4> s, bool sync)
  { return(bind(slot(&TunnelCallback4<R,P1,P2,P3,P4>::tunnel), s, tunnel, sync));
  }



/****************************************************************
*****  Tunnel 5
****************************************************************/

template <class R,class P1,class P2,class P3,class P4,class P5>
class TunnelCallback5 : public Tunnel::Callback
{
  public:
    TunnelCallback5(Slot5<R,P1,P2,P3,P4,P5> slot,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5)
: slot_(slot),p1_(p1),p2_(p2),p3_(p3),p4_(p4),p5_(p5) {}
    virtual void invoke() { rv_ = slot_.call(p1_,p2_,p3_,p4_,p5_); }
    R tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        R tmp;
        if (sync) {
          tmp = rv_;
	  delete this;
        }
        return(tmp);
      }
      else
        return(slot_.call(p1_,p2_,p3_,p4_,p5_));
    }
    static R tunnel(P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,Slot5<R,P1,P2,P3,P4,P5> s,Tunnel *tunnel,bool sync) {
      TunnelCallback5<R,P1,P2,P3,P4,P5> *cb = pack(s,p1,p2,p3,p4,p5);
      return(cb->tunnel(tunnel, sync));
    }
  protected:
    Slot5<R,P1,P2,P3,P4,P5> slot_;
    R rv_;
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_;
};

template <class R,class P1,class P2,class P3,class P4,class P5>
   TunnelCallback5<R,P1,P2,P3,P4,P5> *pack(Slot5<R,P1,P2,P3,P4,P5> s,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5)
  {       return(new TunnelCallback5<R,P1,P2,P3,P4,P5>(s,p1,p2,p3,p4,p5));
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4,class P5>
class TunnelCallback5<void,P1,P2,P3,P4,P5> : public Tunnel::Callback
{
  public:
    TunnelCallback5(Slot5<void,P1,P2,P3,P4,P5> slot,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5)
: slot_(slot),p1_(p1),p2_(p2),p3_(p3),p4_(p4),p5_(p5) { }
    virtual void invoke() { slot_.call(p1_,p2_,p3_,p4_,p5_); }
    void tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        if (sync)
          delete this;
      }
      else
        slot_.call(p1_,p2_,p3_,p4_,p5_);
    }
    static void tunnel(P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,Slot5<void,P1,P2,P3,P4,P5> s,Tunnel *tunnel,bool sync) {
      TunnelCallback5<void,P1,P2,P3,P4,P5> *cb = pack(s,p1,p2,p3,p4,p5);
      cb->tunnel(tunnel, sync);
   }
  protected:
    Slot5<void,P1,P2,P3,P4,P5> slot_;
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_;
};
#endif

template <class R,class P1,class P2,class P3,class P4,class P5>
Slot5<R,P1,P2,P3,P4,P5>
  open_tunnel(Tunnel *tunnel, Slot5<R,P1,P2,P3,P4,P5> s, bool sync)
  { return(bind(slot(&TunnelCallback5<R,P1,P2,P3,P4,P5>::tunnel), s, tunnel, sync));
  }



/****************************************************************
*****  Tunnel 6
****************************************************************/

template <class R,class P1,class P2,class P3,class P4,class P5,class P6>
class TunnelCallback6 : public Tunnel::Callback
{
  public:
    TunnelCallback6(Slot6<R,P1,P2,P3,P4,P5,P6> slot,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6)
: slot_(slot),p1_(p1),p2_(p2),p3_(p3),p4_(p4),p5_(p5),p6_(p6) {}
    virtual void invoke() { rv_ = slot_.call(p1_,p2_,p3_,p4_,p5_,p6_); }
    R tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        R tmp;
        if (sync) {
          tmp = rv_;
	  delete this;
        }
        return(tmp);
      }
      else
        return(slot_.call(p1_,p2_,p3_,p4_,p5_,p6_));
    }
    static R tunnel(P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6,Slot6<R,P1,P2,P3,P4,P5,P6> s,Tunnel *tunnel,bool sync) {
      TunnelCallback6<R,P1,P2,P3,P4,P5,P6> *cb = pack(s,p1,p2,p3,p4,p5,p6);
      return(cb->tunnel(tunnel, sync));
    }
  protected:
    Slot6<R,P1,P2,P3,P4,P5,P6> slot_;
    R rv_;
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_; P6 p6_;
};

template <class R,class P1,class P2,class P3,class P4,class P5,class P6>
   TunnelCallback6<R,P1,P2,P3,P4,P5,P6> *pack(Slot6<R,P1,P2,P3,P4,P5,P6> s,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6)
  {       return(new TunnelCallback6<R,P1,P2,P3,P4,P5,P6>(s,p1,p2,p3,p4,p5,p6));
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4,class P5,class P6>
class TunnelCallback6<void,P1,P2,P3,P4,P5,P6> : public Tunnel::Callback
{
  public:
    TunnelCallback6(Slot6<void,P1,P2,P3,P4,P5,P6> slot,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6)
: slot_(slot),p1_(p1),p2_(p2),p3_(p3),p4_(p4),p5_(p5),p6_(p6) { }
    virtual void invoke() { slot_.call(p1_,p2_,p3_,p4_,p5_,p6_); }
    void tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        if (sync)
          delete this;
      }
      else
        slot_.call(p1_,p2_,p3_,p4_,p5_,p6_);
    }
    static void tunnel(P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6,Slot6<void,P1,P2,P3,P4,P5,P6> s,Tunnel *tunnel,bool sync) {
      TunnelCallback6<void,P1,P2,P3,P4,P5,P6> *cb = pack(s,p1,p2,p3,p4,p5,p6);
      cb->tunnel(tunnel, sync);
   }
  protected:
    Slot6<void,P1,P2,P3,P4,P5,P6> slot_;
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_; P6 p6_;
};
#endif

template <class R,class P1,class P2,class P3,class P4,class P5,class P6>
Slot6<R,P1,P2,P3,P4,P5,P6>
  open_tunnel(Tunnel *tunnel, Slot6<R,P1,P2,P3,P4,P5,P6> s, bool sync)
  { return(bind(slot(&TunnelCallback6<R,P1,P2,P3,P4,P5,P6>::tunnel), s, tunnel, sync));
  }



/****************************************************************
*****  Tunnel 7
****************************************************************/

template <class R,class P1,class P2,class P3,class P4,class P5,class P6,class P7>
class TunnelCallback7 : public Tunnel::Callback
{
  public:
    TunnelCallback7(Slot7<R,P1,P2,P3,P4,P5,P6,P7> slot,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6,P7 p7)
: slot_(slot),p1_(p1),p2_(p2),p3_(p3),p4_(p4),p5_(p5),p6_(p6),p7_(p7) {}
    virtual void invoke() { rv_ = slot_.call(p1_,p2_,p3_,p4_,p5_,p6_,p7_); }
    R tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        R tmp;
        if (sync) {
          tmp = rv_;
	  delete this;
        }
        return(tmp);
      }
      else
        return(slot_.call(p1_,p2_,p3_,p4_,p5_,p6_,p7_));
    }
    static R tunnel(P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6,P7 p7,Slot7<R,P1,P2,P3,P4,P5,P6,P7> s,Tunnel *tunnel,bool sync) {
      TunnelCallback7<R,P1,P2,P3,P4,P5,P6,P7> *cb = pack(s,p1,p2,p3,p4,p5,p6,p7);
      return(cb->tunnel(tunnel, sync));
    }
  protected:
    Slot7<R,P1,P2,P3,P4,P5,P6,P7> slot_;
    R rv_;
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_; P6 p6_; P7 p7_;
};

template <class R,class P1,class P2,class P3,class P4,class P5,class P6,class P7>
   TunnelCallback7<R,P1,P2,P3,P4,P5,P6,P7> *pack(Slot7<R,P1,P2,P3,P4,P5,P6,P7> s,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6,P7 p7)
  {       return(new TunnelCallback7<R,P1,P2,P3,P4,P5,P6,P7>(s,p1,p2,p3,p4,p5,p6,p7));
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4,class P5,class P6,class P7>
class TunnelCallback7<void,P1,P2,P3,P4,P5,P6,P7> : public Tunnel::Callback
{
  public:
    TunnelCallback7(Slot7<void,P1,P2,P3,P4,P5,P6,P7> slot,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6,P7 p7)
: slot_(slot),p1_(p1),p2_(p2),p3_(p3),p4_(p4),p5_(p5),p6_(p6),p7_(p7) { }
    virtual void invoke() { slot_.call(p1_,p2_,p3_,p4_,p5_,p6_,p7_); }
    void tunnel(Tunnel *tunnel, bool sync = false) {
      if (tunnel) {
        tunnel->send(this, sync);
        if (sync)
          delete this;
      }
      else
        slot_.call(p1_,p2_,p3_,p4_,p5_,p6_,p7_);
    }
    static void tunnel(P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6,P7 p7,Slot7<void,P1,P2,P3,P4,P5,P6,P7> s,Tunnel *tunnel,bool sync) {
      TunnelCallback7<void,P1,P2,P3,P4,P5,P6,P7> *cb = pack(s,p1,p2,p3,p4,p5,p6,p7);
      cb->tunnel(tunnel, sync);
   }
  protected:
    Slot7<void,P1,P2,P3,P4,P5,P6,P7> slot_;
    P1 p1_; P2 p2_; P3 p3_; P4 p4_; P5 p5_; P6 p6_; P7 p7_;
};
#endif

template <class R,class P1,class P2,class P3,class P4,class P5,class P6,class P7>
Slot7<R,P1,P2,P3,P4,P5,P6,P7>
  open_tunnel(Tunnel *tunnel, Slot7<R,P1,P2,P3,P4,P5,P6,P7> s, bool sync)
  { return(bind(slot(&TunnelCallback7<R,P1,P2,P3,P4,P5,P6,P7>::tunnel), s, tunnel, sync));
  }




#ifdef SIGC_CXX_NAMESPACES
} // namespace
#endif
 
#endif
